package com.madeu.controller.web.webauthmenurelation;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webauthmenurelation.WebAuthMenuRelationService;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebAuthMenuRelationController extends ManagerDraftAction{

	@Autowired
	private WebAuthMenuRelationService webAuthMenuRelationService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	
	/**
	 * 권한별 메뉴 정보 리스트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webauthmenurelation/selectListAuthMenuRelation.do")
	public ModelAndView selectListAuthMenuRelation(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebAuthMenuRelationController selectListAuthMenuRelation START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webAuthMenuRelationService.selectListAuthMenuRelation(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebAuthMenuRelationController selectListAuthMenuRelation END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * 권한별 메뉴 정보 저장
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webauthmenurelation/updateAuthMenuRelation.do")
	public ModelAndView updateAuthMenuRelation(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebAuthMenuRelationController updateAuthMenuRelation START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webAuthMenuRelationService.updateAuthMenuRelation(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
			
			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();
	
				insertMap.put("url", "/webauthmenurelation/updateAuthMenuRelation.do");
				insertMap.put("func", "updateAuthMenuRelation");
				insertMap.put("funcName", "권한별 메뉴 저장");
				insertMap.put("service", "webAuthMenuRelationService");
				insertMap.put("serviceName", "권한별 메뉴 저장");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
	
				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("WebAuthMenuRelationController updateAuthMenuRelation END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
}
